Subject: Re: [PATCH] require_work_tree: Look for top-level instead of is-inside-work-tree

From: Michael J Gruber <[email-masked]>
Date: Tue, 03 Aug 2010 09:57:35 +0200

Junio C Hamano venit, vidit, dixit 02.08.2010 19:46:
> Michael J Gruber <[email-masked]> writes:
> 
>> An alternative which does not change the established behavior of
>> require_work_tree would be changing the order of require_work_tree and
>> cd_to_top_level in the callers where possible along the lines of
>>
>> http://mid.gmane.org/[email-masked]
>>
>> which got lost somehow. (The other callers, as mentioned by Junio, would
>> need to be changed differently, e.g. by moving cd_to... earlier.)
> 
> Doesn't it sound stupid to "cd-to-toplevel" and then "require-work-tree"?

It sounds outright silly, agreed.
Though, unless you know the implementation, "cd_to_toplevel" may succeed
cd'ing to what "rev-parse --show-toplevel" returns without
require_work_tree being happy.

But don't we try to preserve existing behavior unless it's a bug? We
certainly have a mismatch of behavior and documentation here. The
question is whether we want to break anyone who relied on
"require_work_tree" dieing when cwd is not within the work-tree.

> 
> If you can go to the top-level, and once you successfully got there, you
> already _know_ that you have a work tree (and also you already know at
> that point you are in the work tree).  The reason why "require-work-tree"
> has been placed before "cd-to-toplevel" is exactly for that purpose, I
> think.  It is possible that some callers wanted to "require-work-tree" to
> mean "I want you to not just _have_ a work tree, but actually be _in_ it",
> but I somehow doubt it.  It is more like "I am going to ask you to go to
> the top, but let's make sure that you do have a top before doing so", I
> think.

Well, if people relied on current behavior...
I didn't, I don't mind changing this, in fact I'm usually in "changing
mood" and running into the "preserve behavior" wall ;)

In any case, I think "require_work_tree" should really test whether we
can cd into the worktree, i.e. whether a cd_to_toplevel would succeed,
and not just whether "rev-parse --show-toplevel" returns a non-empty string.

> 
> I on the other hand do not think it is wrong to lose the existing calls to
> require-work-tree if you know that you are going to call cd-to-toplevel
> before doing any git operation that needs to have a work-tree, though.
> 
>> Another problem I noticed back then (I was away since) was that a
>> relative GIT_WORK_TREE is left in place after a cd_to_top_level and
>> messes things up completely - it does not seem to be relative to
>> GIT_DIR. So, there seems to be more to fix in this area.
> 
> I agree; I don't think GIT_WORK_TREE was designed to be anything but an
> absolute path to begin with.  If a command chdir's around and exports the
> environment to its hooks and subcommands, it should be prepared to adjust
> it before doing so.

We do have some magic to re-export a relative GIT_DIR as absolute, and
the doc says GIT_WORK_TREE is relative to GIT_DIR. We even have a test
which succeeds by pure chance, as playing around with different layouts
shows. I'll try to come up at least with tests for this when I get to it.

Cheers,
Michael